;****************************************************************************
;	This is the file commands for the PRO32 DOS Extender.
;	the usage of each routine is listed above it
;	see fdoc.txt for misc. info
;****************************************************************************


;Definitions:
SEEKBEG		=	0
SEEKCUR		=	1
SEEKEND		=	2
R		=	0
W		=	1
RW		=	2


;****************************************************************************
;fclose
;takes handle of file to close in bx
fclose proc
	;takes file handle in bx
	mov ah,3eh
	int 21h
	ret
ENDP

;****************************************************************************
;fopen
;takes access mode in al (0 = read only, 1 = write only, 2 = both)
;name of file in ds:esi
fopen proc

	mov ah,3dh
	mov [Reax],eax
	push es
	mov ax,cs:[6]
	xor edi,edi
	mov es,ax

WRTOLoop:
	mov al,ds:[esi]
	mov es:[edi],al
	inc esi
	inc edi
	cmp al,0
	jne WRTOLoop

	mov ax,cs:[8]
	mov [Recx],0
	mov [Rds],ax
	mov [Redx],0

	mov ax,300h
	mov bx,21h
	mov dx,ds
	xor ecx,ecx
	mov es,dx
	mov edi,offset Redi
	int 31h


	mov ah,byte ptr [Redi + 20h]
	sahf
	jnc OAOK

	mov eax,[Reax]
	cmp ax,2
	jne OAOK

 ;File doesn't exist, so create it
	mov [Reax],3c00h
	mov ax,cs:[8]
	mov [Recx],20h
	mov [Rds],ax
	mov [Redx],0

	mov ax,300h
	mov bx,21h
	mov dx,ds
	xor ecx,ecx
	mov es,dx
	mov edi,offset Redi
	int 31h

OAOK:
	mov eax,[Reax]		;ax has file handle
	pop es
	ret

ENDP

;****************************************************************************
;fread
;takes file handle in bx, number of bytes to read in cx
;returns data in file buffer (selector = cs:[6])
;returns true number of bytes read in ax (if less than cx, then eof)
fread proc

	push es
	mov [Reax],3f00h
	mov [Rebx],ebx
	mov ax,cs:[8]
	mov [Recx],ecx
	push ds
	mov [Rds],ax
	pop es
	mov [Redx],0
	mov edi,offset Redi
	mov ax,300h
	mov bx,21h
	xor ecx,ecx
	int 31h
	mov eax,[Reax]

	pop es
	ret
ENDP

;****************************************************************************
;fwrite
;takes file handle in bx
;number of bytes to write in cx (0=makes it end of file (truc or extends))
;fs:esi is zero terminated string to write
;returns number of bytes written in ax (if != cx, then an error occured)
fwrite proc

	mov [Rebx],ebx
	mov [Recx],ecx
	push es
	mov ax,cs:[6]
	xor edi,edi
	mov es,ax

WRTWLoop:
	dec cx
	mov al,fs:[esi]
	mov es:[edi],al
	inc esi
	inc edi
	cmp cx,0
	jne WRTWLoop

	mov [Reax],4000h
	mov ax,cs:[8]
	mov [Rds],ax
	mov [Redx],0

	mov ax,300h
	mov bx,21h
	mov dx,ds
	xor ecx,ecx
	mov es,dx
	mov edi,offset Redi
	int 31h

	mov eax,[Reax]		;ax has file handle
	pop es

	ret
ENDP

;****************************************************************************
;fseek
;takes file handle in bx, cx:dx is number of bytes to move
;al is SEEKBEG from beginning, SEEKCUR from current, SEEKEND from end
fseek proc

	mov ah,42h
	int 21h

	ret
ENDP